#include <ncursesw/ncurses.h>
#include <locale.h>
#include <unistd.h>
#include <iomanip>
#include <ctime>
#include <string>
#include <sstream>
#include <vector>
using namespace std;
class number
{
	private:
	vector<vector<bool> > block;
	public:
	void set_num(char num)
	{
		if(num=='0')
		{
			block=
            {
                {1,1,1},
                {1,0,1},
                {1,0,1},
                {1,0,1},
                {1,1,1}
            };
		}
		else if(num=='1')
		{
			block=
			{
				{0,0,1},
				{0,0,1},
				{0,0,1},
				{0,0,1},
				{0,0,1}
			};
		}
		else if(num=='2')
		{
			block=
			{
				{1,1,1},
				{0,0,1},
				{1,1,1},
				{1,0,0},
				{1,1,1}
			};
		}
		else if(num=='3')
		{
			block=
			{
				{1,1,1},
				{0,0,1},
				{1,1,1},
				{0,0,1},
				{1,1,1}
			};
		}
		else if(num=='4')
		{
			block=
			{
				{1,0,1},
				{1,0,1},
				{1,1,1},
				{0,0,1},
				{0,0,1}
			};
		}
		else if(num=='5')
		{
			
			block=
			{
				{1,1,1},
				{1,0,0},
				{1,1,1},
				{0,0,1},
				{1,1,1}
			};
		}
		else if(num=='6')
		{
			block=
			{
				{1,1,1},
				{1,0,0},
				{1,1,1},
				{1,0,1},
				{1,1,1}
			};
		}
		else if(num=='7')
		{
			block=
			{
				{1,1,1},
				{0,0,1},
				{0,0,1},
				{0,0,1},
				{0,0,1}
			};
		}
		else if(num=='8')
		{
			block=
			{
				{1,1,1},
				{1,0,1},
				{1,1,1},
				{1,0,1},
				{1,1,1}
			};
		}
		else if(num=='9')
		{
			block=
			{
				{1,1,1},
				{1,0,1},
				{1,1,1},
				{0,0,1},
				{1,1,1}
			};
		}
		else if(num==':')
		{
			block=
			{
				{0,0,1},
				{0,0,0},
				{0,0,1},
				{0,0,0},
				{0,0,1}
			};
		}
	}
	void print(int line)
	{
		for(int i=0;i<3;i++)
		{
			if(block[line][i]==0)
			{
				printw("  ");
			}
			else
			{
				if(!has_colors())
				{
					printw("##");
				}
				else
				{
					start_color();
					init_pair(1,COLOR_BLACK,COLOR_BLUE);
					attron(COLOR_PAIR(1));
					printw("  ");
					attroff(COLOR_PAIR(1));
				}
			}
		}
	}
};
int main()
{
	setlocale(LC_ALL,"");
	initscr();
	number nums[8];
	while(true)
	{
		timeout(1000);
		clear();
		time_t t_int=time(NULL);
		tm* t=localtime(&t_int);
		ostringstream str;
		str
		<<setw(2)<<t->tm_hour
		<<":"
		<<setw(2)<<t->tm_min
		<<":"
		<<setw(2)<<t->tm_sec;
		for(int i=0;i<8;i++)
		{
			nums[i].set_num(str.str().c_str()[i]);
		}
		int x,y;
		getmaxyx(stdscr,y,x);
		for(int i=0;i<5;i++)
		{
			move((y-6)/2+i,(x-64)/2);
			for(int j=0;j<8;j++)
			{
				nums[j].print(i);
				printw(" ");
			}/*
			printw("\n");*/
		}
		str.str("");
		str<<t->tm_year+1900<<"年"<<t->tm_mon+1<<"月"<<t->tm_mday<<"日"<<" "<<t->tm_hour<<":"<<t->tm_min<<":"<<t->tm_sec;
		move((y-6)/2+5,(x-str.str().length())/2);
		printw(str.str().c_str());
		refresh();
		int i=getch();
		if(i=='q'||i=='Q')
		{
			break;
		}
		//sleep(1);
	}
	endwin();
	return 0;
}
